// ATLBandit.h : Declaration of the CATLBandit

#ifndef __ATLBANDIT_H_
#define __ATLBANDIT_H_

#include "resource.h"       // main symbols
#include <atlctl.h>
#include "OneArmedBanditATLCP.h"


/////////////////////////////////////////////////////////////////////////////
// CATLBandit
class ATL_NO_VTABLE CATLBandit : 
	public CComObjectRootEx<CComSingleThreadModel>,
	public CStockPropImpl<CATLBandit, IATLBandit, &IID_IATLBandit, &LIBID_ONEARMEDBANDITATLLib>,
	public CComControl<CATLBandit>,
	public IPersistStreamInitImpl<CATLBandit>,
	public IOleControlImpl<CATLBandit>,
	public IOleObjectImpl<CATLBandit>,
	public IOleInPlaceActiveObjectImpl<CATLBandit>,
	public IViewObjectExImpl<CATLBandit>,
	public IOleInPlaceObjectWindowlessImpl<CATLBandit>,
	public IConnectionPointContainerImpl<CATLBandit>,
	public IPersistStorageImpl<CATLBandit>,
	public ISpecifyPropertyPagesImpl<CATLBandit>,
	public IQuickActivateImpl<CATLBandit>,
	public IDataObjectImpl<CATLBandit>,
	public IProvideClassInfo2Impl<&CLSID_ATLBandit, &DIID__IATLBanditEvents, &LIBID_ONEARMEDBANDITATLLib>,
	public IPropertyNotifySinkCP<CATLBandit>,
	public CComCoClass<CATLBandit, &CLSID_ATLBandit>,
	public CProxy_IATLBanditEvents< CATLBandit >
{
public:
	CATLBandit()
	{
		_tcscpy(m_symbols, _T("JJJ"));
	}

DECLARE_REGISTRY_RESOURCEID(IDR_ATLBANDIT)

DECLARE_PROTECT_FINAL_CONSTRUCT()

BEGIN_COM_MAP(CATLBandit)
	COM_INTERFACE_ENTRY(IATLBandit)
	COM_INTERFACE_ENTRY(IDispatch)
	COM_INTERFACE_ENTRY(IViewObjectEx)
	COM_INTERFACE_ENTRY(IViewObject2)
	COM_INTERFACE_ENTRY(IViewObject)
	COM_INTERFACE_ENTRY(IOleInPlaceObjectWindowless)
	COM_INTERFACE_ENTRY(IOleInPlaceObject)
	COM_INTERFACE_ENTRY2(IOleWindow, IOleInPlaceObjectWindowless)
	COM_INTERFACE_ENTRY(IOleInPlaceActiveObject)
	COM_INTERFACE_ENTRY(IOleControl)
	COM_INTERFACE_ENTRY(IOleObject)
	COM_INTERFACE_ENTRY(IPersistStreamInit)
	COM_INTERFACE_ENTRY2(IPersist, IPersistStreamInit)
	COM_INTERFACE_ENTRY(IConnectionPointContainer)
	COM_INTERFACE_ENTRY(ISpecifyPropertyPages)
	COM_INTERFACE_ENTRY(IQuickActivate)
	COM_INTERFACE_ENTRY(IPersistStorage)
	COM_INTERFACE_ENTRY(IDataObject)
	COM_INTERFACE_ENTRY(IProvideClassInfo)
	COM_INTERFACE_ENTRY(IProvideClassInfo2)
	COM_INTERFACE_ENTRY_IMPL(IConnectionPointContainer)
END_COM_MAP()

BEGIN_PROP_MAP(CATLBandit)
	PROP_DATA_ENTRY("_cx", m_sizeExtent.cx, VT_UI4)
	PROP_DATA_ENTRY("_cy", m_sizeExtent.cy, VT_UI4)
	PROP_ENTRY("NumberOfSymbols", 1, CLSID_BanditPP) 
	PROP_ENTRY("BackColor", DISPID_BACKCOLOR, CLSID_StockColorPage)
	PROP_ENTRY("ForeColor", DISPID_FORECOLOR, CLSID_StockColorPage)
	// Example entries
	// PROP_ENTRY("Property Description", dispid, clsid)
	// PROP_PAGE(CLSID_StockColorPage)
END_PROP_MAP()

BEGIN_CONNECTION_POINT_MAP(CATLBandit)
	CONNECTION_POINT_ENTRY(IID_IPropertyNotifySink)
	CONNECTION_POINT_ENTRY(DIID__IATLBanditEvents)
END_CONNECTION_POINT_MAP()

BEGIN_MSG_MAP(CATLBandit)
	CHAIN_MSG_MAP(CComControl<CATLBandit>)
	DEFAULT_REFLECTION_HANDLER()
	MESSAGE_HANDLER(WM_LBUTTONDOWN, OnLButtonDown)
END_MSG_MAP()
// Handler prototypes:
//  LRESULT MessageHandler(UINT uMsg, WPARAM wParam, LPARAM lParam, BOOL& bHandled);
//  LRESULT CommandHandler(WORD wNotifyCode, WORD wID, HWND hWndCtl, BOOL& bHandled);
//  LRESULT NotifyHandler(int idCtrl, LPNMHDR pnmh, BOOL& bHandled);



// IViewObjectEx
	DECLARE_VIEW_STATUS(VIEWSTATUS_SOLIDBKGND | VIEWSTATUS_OPAQUE)

// IATLBandit
public:
	STDMETHOD(Play)();
	STDMETHOD(get_NumberOfSymbols)(/*[out, retval]*/ short *pVal);
	STDMETHOD(put_NumberOfSymbols)(/*[in]*/ short newVal);

	HRESULT OnDraw(ATL_DRAWINFO& di)
	{
		const RECT& rc = *reinterpret_cast<const RECT*>(di.prcBounds);
		HDC dc = di.hdcDraw;
		
		COLORREF colorBack, colorFore;
		OleTranslateColor( m_clrForeColor, NULL, &colorFore );
		OleTranslateColor( m_clrBackColor, NULL, &colorBack );

		//    
		float ctrlWidth = float( rc.right - rc.left );
		float ctrlHeight = float( rc.bottom - rc.top );

		//   
		HBRUSH brush = CreateSolidBrush( colorBack );
		HBRUSH oldBrush = static_cast<HBRUSH>(SelectObject( dc, brush ) );

		HPEN pen = CreatePen( PS_SOLID, 3, colorFore );
		HPEN oldPen = static_cast<HPEN>(SelectObject( dc, pen ) );

		HFONT SymbolFont = CreateFont( long(ctrlHeight / 1.1), long(ctrlWidth/6), 
			0, 0, 0, 0, 0, 0, SYMBOL_CHARSET, 0, 0, 0, 0,"WingDings" ); 

		HFONT oldFont = static_cast<HFONT>(SelectObject( dc, SymbolFont ) );

		//   
		Rectangle( dc, rc.left, rc.top, rc.right, rc.bottom );
		SetBkMode( dc, TRANSPARENT );

		//  
		SetTextColor( dc, colorFore );
		RECT rect;
		CopyRect( &rect, &rc );

		TCHAR strDisplay[ 5 ];
		_stprintf( strDisplay, "%c %c %c",
			m_symbols[ 0 ], m_symbols[ 1 ], m_symbols[ 2 ] );
	
		DrawText( dc, strDisplay, 5, &rect, DT_SINGLELINE | DT_CENTER | DT_VCENTER  );

		//   
		long onethird = long(ctrlWidth / 3);
		POINT ptTop = { rc.left, rc.top };
		POINT ptBtm = { rc.left, rc.bottom };

		ptTop.x += onethird; ptBtm.x += onethird;
		MoveToEx( dc, ptTop.x, ptTop.y, NULL );
		LineTo( dc, ptBtm.x, ptBtm.y );

		ptTop.x += onethird; ptBtm.x += onethird;
		MoveToEx( dc, ptTop.x, ptTop.y, NULL );
		LineTo( dc, ptBtm.x, ptBtm.y );


		//   
		SelectObject( dc, oldFont );
		SelectObject( dc, oldPen );
		SelectObject( dc, oldBrush );

		DeleteObject( brush );
		DeleteObject( pen );
		DeleteObject( SymbolFont );

		return S_OK;
	}
	OLE_COLOR m_clrBackColor;
	OLE_COLOR m_clrForeColor;
protected:
	TCHAR m_symbols[3];
	short m_numberOfSymbols;
	LRESULT OnLButtonDown(UINT uMsg, WPARAM wParam, LPARAM lParam, BOOL& bHandled)
	{
		Fire_Click();
		return 0;
	}
};

#endif //__ATLBANDIT_H_
