// BanditPP.h : Declaration of the CBanditPP

#ifndef __BANDITPP_H_
#define __BANDITPP_H_

#include "resource.h"       // main symbols

EXTERN_C const CLSID CLSID_BanditPP;

/////////////////////////////////////////////////////////////////////////////
// CBanditPP
class ATL_NO_VTABLE CBanditPP :
	public CComObjectRootEx<CComSingleThreadModel>,
	public CComCoClass<CBanditPP, &CLSID_BanditPP>,
	public IPropertyPageImpl<CBanditPP>,
	public CDialogImpl<CBanditPP>
{
public:
	CBanditPP() 
	{
		m_dwTitleID = IDS_TITLEBanditPP;
		m_dwHelpFileID = IDS_HELPFILEBanditPP;
		m_dwDocStringID = IDS_DOCSTRINGBanditPP;
	}

	enum {IDD = IDD_BANDITPP};

DECLARE_REGISTRY_RESOURCEID(IDR_BANDITPP)

DECLARE_PROTECT_FINAL_CONSTRUCT()

BEGIN_COM_MAP(CBanditPP) 
	COM_INTERFACE_ENTRY(IPropertyPage)
END_COM_MAP()

BEGIN_MSG_MAP(CBanditPP)
	CHAIN_MSG_MAP(IPropertyPageImpl<CBanditPP>)
	MESSAGE_HANDLER(WM_INITDIALOG, OnInitDialog)
	COMMAND_HANDLER(IDC_NUMSYMBOLS, EN_CHANGE, OnChangeNumsymbols)
END_MSG_MAP()
// Handler prototypes:
//  LRESULT MessageHandler(UINT uMsg, WPARAM wParam, LPARAM lParam, BOOL& bHandled);
//  LRESULT CommandHandler(WORD wNotifyCode, WORD wID, HWND hWndCtl, BOOL& bHandled);
//  LRESULT NotifyHandler(int idCtrl, LPNMHDR pnmh, BOOL& bHandled);

	STDMETHOD(Apply)(void)
	{
	    CComQIPtr<IATLBandit> pIBandit(m_ppUnk[0]);

        pIBandit->put_NumberOfSymbols(GetDlgItemInt(IDC_NUMSYMBOLS));

		m_bDirty = FALSE;
		return S_OK;
	}
	LRESULT OnInitDialog(UINT uMsg, WPARAM wParam, LPARAM lParam, BOOL& bHandled)
	{
        CComQIPtr<IATLBandit> pIBandit(m_ppUnk[0]);
    
        short i = 0; 
        pIBandit->get_NumberOfSymbols(&i);
        SetDlgItemInt(IDC_NUMSYMBOLS, i); 
		return 0;
	}
	LRESULT OnChangeNumsymbols(WORD wNotifyCode, WORD wID, HWND hWndCtl, BOOL& bHandled)
	{
		SetDirty(TRUE);
		return 0;
	}
};

#endif //__BANDITPP_H_
